/**
 * Created by qianqian on 23/7/27.
 */
;(function ($) {
    var docEl = document.documentElement;
    var winW;//屏幕的宽度
    var intervalCode, countSeconds = 10;   //计时器的毫秒变量 
    function compareObj (obj1, obj2) {
        for (var key in obj1) {
            if (obj1[key] != obj2[key]) {
                return false;
            }
        }
        return true;
    }
    var main = {
        init: function () {
            var httpUrl = new lib.httpurl(location.href);
            var params = httpUrl.params;
            var title = '商品详情';
            document.title = title;

            this.item_uid = params.item_uid;
            this.write_type = params['type'] ? decodeURIComponent(params['type']) : '';
            this.activity_type = '';

            if(params['_code_']){
                lib.cookie.set('_code_',params['_code_'])
            }

            if(params['self_code'] && lib.cookie.get('invitation_code')){
                var _selfcode = '1-'+lib.cookie.get('invitation_code')+'-'+this.item_uid;
                if(params['self_code'].split("-")[1] != lib.cookie.get('invitation_code')){
                    var _precode = '';

                    if(!(lib.cookie.get('precode'))){
                        _precode = decodeURIComponent(params['self_code']);
                    }

                    lib.cookie.set('precode',_precode);
                    // todo 只是添加参数，不能替换掉
                    location.replace('detail.html?item_uid='+params.item_uid+'&self_code='+_selfcode+'&pre_code='+_precode);
                    return;
                }else if(params['pre_code']){
                    var _precode = params['pre_code'];
                    lib.cookie.set('precode',_precode);
                }
            }else if(lib.cookie.get('invitation_code')){
                var _selfcode = '1-'+lib.cookie.get('invitation_code')+'-'+this.item_uid;
                // todo 只是添加参数，不能替换掉
                location.replace('detail.html?item_uid='+params.item_uid+'&self_code='+_selfcode);
                return;
            }

            this.itemsList = [];
            this.service_list = [];
            this.itemsList.push(this.item_uid);
            this.stock_num = 0;
            this.NO_ITEM = '<div class="main"><div class="main-icon"></div><p class="tips">商品已下架/商品不存在~</p><a class="btn-null" href="index.html">返回首页</a></div>';

            this.page = 0;
            this.page_filter = [0,0,0];
            this.filter = false;          // 好中差评加载结束标志
            this.add_comment = false;     // 全部评论加载结束标志
            this.isAjaxGetservice = false;// 获取服务标志
            this.reload_time = 1000;      // 如果刷新失败，1秒后再刷新

            lib.api.init({
                app_key:'c0f1a2693eb2d0b7f3c96ca7fc40b784',
                app_pwd:'c4991e23d6126bfa7c39fd32f6e566f1',
                testApi:''
            });

            var that = this;
            this.infiniteScroll = lib.infiniteScroll.init({
                bufferPx: 150, // 距离低端px就触发onNear事件
                time: 200, // 设置延迟触发onNear
                onNear: function () {
                    if(that.filter){
                        that.renderFilterComment(that.filter_index-1,that.filter_score,that.filter_target);
                    }

                    if(that.add_comment){
                        that.renderComment();
                    }
                },
                end: function () {
                    return that.isEnd;
                }
            });

            // 初始化lazyload
            lib.lazyload.init({loadHidden:false});

            // gotop
            new lib.goTop({position:{bottom:65}});

            //对客户端的图文详情和评论列表的支持
            switch(this.write_type){
                //客户端的图文详情
                case 'content':
                    this.render(true);
                    break;
                //客户端的评论列表
                case 'comment':
                    this.renderComment(true);
                    //return;
                    break;
                //h5详情
                default :
                    $('.container').show();
                    winW = docEl.getBoundingClientRect().width;
                    this.brand_id = params.brand_id || null;
                    this.sku_uid = '';

                    this.num = (lib.storage.get('cartNum') > 0) ? lib.storage.get('cartNum') : 0;
                    if(this.num){
                        $('.cart-num').show().html(this.num);
                    }

                    this.topbar = new ctrl.topBar({
                        isNoTitle:true,
                        title: title,
                        left:{
                            normal:false,
                            custom:{
                                text:'',
                                className:'custom-top-back',
                                hrefContent:'javascript:history.go(-1);'
                            }
                        },
                        right:[
                            {
                                html:'<a href="javascript:void(0)" class="fav custom-top-fav"><i class="iconfont" data-icon="&#xe60c;">&#xe60c;</i></a>'
                            },
                            {
                                html:'<a href="javascript:void(0)" class="more custom-top-share"></a>'
                            }
                        ]
                    });

                    if(lib.login.isLogin()){
                        this.renderWithLogin(); //已登录
                    }else{
                        this.render();          //未登录
                    }

                    this.contentTab();
                    this.addEvent();
            }

            // 联系客服展示否
            if ($('.service').attr('href') != 'javascript:;') {
                $('.service').parent().show();
            }

            // 分享配置
            if ('true' == 'true') {
                this.addWeixinShare();
            }
        },

        addWeixinShare: function () {
            var interval;
            var num = 8; // 最多6次，4s
            lib.WeixinApi.init({
                url: 'http://m.aisleep.com/wxsign/',
                debug: false,
                ready: function (Api) {
                    interval = setInterval(function () {
                        if (!num) {
                            clearInterval(interval);
                            return;
                        } else {
                            num --;
                        }

                        var desc = $('#items h1').html();
                        var imgUrl = document.images[0].src;

                        if (!desc) {
                            return;
                        } else {
                            clearInterval(interval);
                        }

                        var wxData = {
                            "appId": Api.sign.appId,
                            "imgUrl" : imgUrl,
                            "link" : location.href,
                            "desc" : desc,
                            "title" : "AiSleep睡眠博士官方商城"
                        };
                        var timelineCfg = {
                            "appId": Api.sign.appId,
                            "imgUrl" : imgUrl,
                            "link" : location.href,
                            "title" : desc
                        };

                        var wxCallbacks = {
                            cancel : function(resp) {
                            },
                            success : function(resp) {
                            }
                        };

                        Api.shareToFriend(wxData, wxCallbacks);
                        Api.shareToTimeline(timelineCfg, wxCallbacks);
                        Api.shareToWeibo(wxData, wxCallbacks);
                        Api.shareToQQ(wxData, wxCallbacks);
                    }, 500);
                }
            })
        },

        goToConfirmOrder: function () {
            // render params
            var params = [];
            if (lib.env.app.isMockuai && (lib.env.app.serverVersion == '-1') && lib.env.os.isAndroid) {
                for (key in lib.storage.data) {
                    params.push(key + '=' + encodeURIComponent(JSON.stringify(lib.storage.data[key])));
                }
            }
            var paramStr = '';
            if (params.length) {
                paramStr = params.join('&');
            }

            location.href = 'order-confirm.html?' + paramStr;
        },

        addEvent : function(){
            var that = this;

            $('#addToCart').on('click',function(){
                if($('.pro-footer').hasClass('soldout')){
                    return;
                }

                if(that.property_num == 1){
                    //console.log(that.property_num);
                    that.addToCart();
                }
                $('#sku-box').attr('control-type','add');
            });

            $('#pay').on('click', function(){
                if($('.pro-footer').hasClass('soldout')){
                    return;
                }

                if(that.property_num == 1){
                    that.pay();
                }
                $('#sku-box').attr('control-type','pay');
            });

            $('.fav').on('click',function(){
                if($(this).hasClass('selected')){
                    that.rmFav(this);
                }else{
                    that.addFav(this);
                }
            });

            //更多
            $('.more').on('click', function(){
                $("body").find('.mask').show();
                $('.more-box').show();
            });
            $('.more-cancel').on('click', function(){
                $('.more-box').hide();
                $("body").find('.mask').hide();
            });

            // 查看服务
            $('#serviceBox').on('click', function(){
                that.getServices();
            });
        },

        // 获取服务
        getServices: function(){
            var that = this;
            if(that.item_label_list && that.item_label_list.length > 0) {
                var serviceList = that.item_label_list;
                var modal_content = [];
                modal_content = '<div class="service-wrapper">';
                for(var i=0;i<serviceList.length;i++){
                    modal_content += '<div class="service-item"><span class="icon"><img src="'+serviceList[i].icon_url+'" alt=""/>'+serviceList[i].label_name+'</span><div>'+serviceList[i].label_desc+'</div></div>';
                }
                modal_content += '</div>';

                ctrl.modal.alert({
                    titleText: '服务说明',
                    btnText: '我知道了',
                    content: modal_content,
                    color: that.item_type==1?'#ff4b55':'#ff4b55',
                    mask: true,
                    callback: function(){
                        this.hide();
                    }
                }).show();
                
                
            }
        },

        //图文详情
        renderDetails: function(isDetail,data){
            if(isDetail){
                $('body').css('backgroundColor','#fff').html('<div id="detail">'+data+'</div>');
            }else{
                $('.pro-detail').css('backgroundColor','#fff').css('padding','15px 0').append(data);
            }
            $('#detail img').parent().css('padding',0);
            if($('#detail table').length > 0) {
                $('#detail table').css('width', 'auto');
                
                var tag = true;
                var a = $('.stores.module').width();
                var $tr = $('table tr'), container = {};
                $.each($tr, function(i, val) {
                    var num = 0, $td = $(val).find('td');
                    for(var j in $td) {
                        if(($td.eq(j).css('background-image') != 'none') && ($td.eq(j).css('background-image') != undefined)) {
                            tag = false;
                            num = num+1;
                        } 
                    }
                    if(num > 0) { 
                        container[i] = {num: num, val: val};
                    }
                });
                if(tag) {
                    return;
                }
                for(var k in container) {
                    var tdw = $(container[k].val).find('td').eq(1).width(); 
                    var result = (a-tdw*(container[k].num-1))/container[k].num;
                    $(container[k].val).find('td a').width(result);
                }
                
            }
        },

        //页面数据获取与渲染,未登录
        render: function (isContent) {
            var that = this;
            if (that.isAjax) {
                return;
            }
            that.isAjax = true;
            lib.api.get({
                api: 'item/get',
                data: {
                    item_uid: this.item_uid
                },
                // mock: {
                //     path: './data/item.json'
                // },
                success: function (data) {
                    that.funcSuccess(data,isContent);
                },
                error: function () {
                    that.funcError();
                },
                complete: function () {
                    that.isAjax = false;
                    that.checkStock();
                }
            })
        },

        //页面数据获取与渲染,已登录
        renderWithLogin: function (isContent) {
            var that = this;
            if (that.isAjax) {
                return;
            }
            that.isAjax = true;
            lib.api.get({
                needLogin:true,
                api: 'item/get',
                data: {
                    item_uid: this.item_uid
                },
                /*mock: {
                    path: './data/item3.json'
                },*/
                success: function (data) {
                    var collection = data.data.item.biz_property_list;
                    for(var item in collection){
                        if(collection[item].code == 'IC_SYS_P_BIZ_000001' && collection[item].value == '1'){
                            $('.fav').addClass('selected');
                        }
                    }
                    that.funcSuccess(data,isContent);
                },
                error: function () {
                    that.funcError();
                    },
                complete: function () {
                    that.isAjax = false;
                    that.checkStock();
                    if($('.item-express span').length){
                        $('.item-express').show();
                    }
                }
            })
        },

        funcError: function(){
            $('body').css('backgroundColor','#fff').find('.top-right').hide();
            $('.container').html(this.NO_ITEM);
        },

        funcSuccess: function(data,isContent){
            var that = this;
            var item_data, valAddService;
            item_data            = data.data.item;
            this.wireless_price    = item_data.wireless_price;
            this.higo_mark       = data.data.item.higo_mark || 0;
            this.higo_extra_info = this.higo_mark ? data.data.item.higo_extra_info : {};
            valAddService        = item_data.service_type_list;
            that.service_type_list = valAddService;
            that.itemSkuList     = item_data.item_sku_list ? item_data.item_sku_list : [];
            that.sku_uid         = item_data.item_sku_list && item_data.item_sku_list[0] ? item_data.item_sku_list[0].sku_uid : {};
            that.sku_title       = item_data.item_name;
            that.icon_url        = item_data.icon_url;
            that.name            = item_data.item_name;
            that.item_label_list = item_data.item_label_list;
            that.delivery_type   = item_data.delivery_type;
            that.item_type       = item_data.item_type || 1;                  // 商品类型，1表示普通商品，11表示套装，12表示充值，13表示秒杀，14表示团购，15表示竞拍，16表示保证金
            that.sale_min_num    = item_data.sale_min_num==0?null:item_data.sale_min_num;
            that.sale_max_num    = item_data.sale_max_num==0?null:item_data.sale_max_num;
            that.limit_buy_count = item_data.limit_buy_count?item_data.limit_buy_count:0;
            item_data.promotion_pric = item_data.promotion_pric ? item_data.promotion_pric : {};
            if(that.item_type == 15 && item_data.item_extra_info.auction_type==1){
                that.act_price   = item_data.promotion_price;
                that.price_unit  = item_data.item_extra_info.price_unit;
            }

            if(that.item_type == 14) {
                that.item_extra      = item_data.item_extra_info;
                that.item_sku_obj    = item_data.item_sku_list[0];
            }

            data || $("body").show();

            // 客户端图文详情
            if(isContent){
                that.renderDetails(isContent,item_data.item_desc);
                return;
            }

            // todo 待联调
            // -------------------start---------------------
            that.item_type = item_data.item_type;
            if(that.item_type != 1){
                var products = [{
                    "sku_uid": item_data.item_sku_list[0].sku_uid,
                    "number":1,
                    "item_type":that.item_type
                }];
                lib.storage.set('products', products);

                that.activity_type = that.item_type;
                that.renderActivity(that.item_type, data);
            }else{
                // 优惠信息展示
                if(item_data.discount_info_list && item_data.discount_info_list.length){
                    that.handleDiscountInfo(item_data.discount_info_list);
                    //that.renderDiscountInfo(item_data.discount_info_list);
                    $('.preferential').show();
                }else{
                    $('.preferential').hide();
                }
            }
            // ------------------- end ---------------------

            if(item_data.status == 5){
                that.setSoldOut('商品已下架');
            }else if(item_data.status == 7){
                if(!item_data.sales_remain_time){
                    $('body').css('backgroundColor','#fff').find('.top-right').hide();
                    $('.container').html(that.NO_ITEM);
                    return;
                }
                if(Number(item_data.sales_remain_time)>0){
                    that.setSaleTimer(Number(item_data.sales_remain_time));
                    that.setSoldOut('商品即将开售');
                }
            }else if (item_data.status != 4){
                $('body').css('backgroundColor','#fff').find('.top-right').hide();
                $('.container').html(that.NO_ITEM);
                return;
            }

            //商品橱窗
            that.renderSlide(item_data.item_image_list);

            data.data.support_store=='1' && that.renderStore(data.data.support_store);

            //单sku商品时不弹出选择框
            //if(item_data.item_sku_list.length == 1){
            //    that.sku_uid = item_data.item_sku_list[0].sku_uid;
            //    that.selectItemSkuUid = item_data.item_sku_list[0].sku_uid;
            //    that.item_number = 1;
            //    that.property_num = 1;
            //    $('.sku-choose').hide();
            //    $('#addToCart').removeClass('sku-trigger');
            //    $('#pay').removeClass('sku-trigger');
            //}

            // 将seller_id写入localstorage，作为确认订单判断是否开启门店功能用
            if(item_data.seller_id){
                var seller_id = item_data.seller_id;
                $('.stores a').attr('href','stores.html?seller_id='+seller_id);
                lib.storage.set('seller_id',seller_id);
            }

            // 显示用户限购相关的提示
            that.getLimitTips(that.sale_min_num, that.sale_max_num, that.limit_buy_count);

            //服务标签
            that.renderServiceTag(that.item_label_list);

            //sku相关处理
            that.handleSku(data);
            that.renderItems(item_data);
            if(valAddService.length > 0){
                that.renderValAddService(valAddService);
            }else{
                $('.sku-service-wrap').remove();
            }

            // 渲染h5自身的商品详情(item_desc)数据
            that.renderDetails(isContent,item_data.item_desc);

            //专场
            if(item_data.item_brand){
                $('.brands').addClass('module');
                that.renderBrands(item_data.item_brand,item_data.item_brand.id);
            }else{
                $("#brands").remove();
            }

            // 判断是否已经售罄，如果售罄展示出来
            if(!that.pro_stock_num){
                that.setSoldOut();
            }
            if(that.activity_type!='') {
                $('.preferential').remove();
                $('.activity-bottom').show();
            } else if(that.activity_type==''){
                $('.activity-bottom').remove();
                $('.pro-footer').show();
            } else {
                $('.activity-timer').remove();
                $('.activity-bottom').remove();
            }

            if($('#serviceBox .label').length < 1) {
                $('#serviceBox').hide();
            }

            lib.lazyload.trigger();

            //存入浏览历史
            that.setHistory(item_data);
        },

        renderServiceTag: function(item_label_list) {
            if(item_label_list && item_label_list.length > 0) {
                var serviceTagobj = {};
                serviceTagobj.status = true;
                serviceTagobj.item = item_label_list;
            } else {
                var serviceTagobj = {};
                serviceTagobj.status = false;
            }
            var tpl = $('#serviceTagBox').html();
            $('#serviceBox').html(_.template(tpl)({
                serviceTagBox: serviceTagobj
            }));
        },

        getLimitTips: function(sale_min_num, sale_max_num, limit_buy_count){
            // 这里有什么展示什么，没有考虑逻辑关系，所以部分异常情况通过管理后台控制
            // 为true表示已添加了提示，再添加时需要加‘，’
            var hasTip = false;
            var buy_number_tip = [];
            if(sale_min_num > 1){
                if(hasTip){
                    buy_number_tip[buy_number_tip.length] = '，';
                }
                buy_number_tip[buy_number_tip.length] = sale_min_num+'件起购';
                hasTip = true;
            }
            if(sale_min_num < sale_max_num){
                if(hasTip){
                    buy_number_tip[buy_number_tip.length] = '，';
                }
                buy_number_tip[buy_number_tip.length] = '每单限购'+sale_max_num+'件';
                hasTip = true;
            }
            if(limit_buy_count){
                if(hasTip){
                    buy_number_tip[buy_number_tip.length] = '，';
                }
                buy_number_tip[buy_number_tip.length] = '每人限购'+limit_buy_count+'件';
                hasTip = true;
            }
            if(hasTip){
                $('.buy-number-append').html(buy_number_tip.join(''));
            }else{
                $('.buy-number-append').remove();
            }
        },

        // 商品售光或者不存在
        setSoldOut: function(txt){
            $('.pro-footer').addClass('soldout');
            $('.sku-dialog').addClass('soldout');
            txt && $('.no-stock').text(txt);
            $('#pay').removeClass('sku-trigger').unbind('click');
            $('#addToCart').removeClass('sku-trigger').unbind('click');
        },

        // 预售商品的倒计时时间设置
        setSaleTimer: function(time){
            var that = this;
            //计算倒计时的时分秒，并传到倒计时的组件中去
            if(time){
                var hour = Math.floor(time/3600);
                var minute = Math.floor((time-hour*3600)/60);
                var second = Number(time-hour*3600-minute*60).toFixed(1);

                var count = [hour,minute,second];
                that.renderTime(count);
            }
        },

        // 预售倒计时显示
        renderTime:function(count){
            var that = this;
            this.cd = null;

            var last_seconds = parseInt(count[0])*3600 + parseInt(count[1]*60) + parseInt(count[2]*10)/10;
            //console.log(count[0],count[1],count[2],last_seconds);
            if( last_seconds > 0){
                that.cd = lib.countdown({
                    endDate: "+"+last_seconds.toString(),
                    interval: 1000,
                    onUpdate: function(data){
                        //console.log(data);
                        var hour = data.days*24+data.hours;
                        $(".sales-timer span").text((hour<10?'0'+hour:hour) + ':'+(data.minutes<10?'0'+data.minutes:data.minutes) + ':' + (data.seconds<10?'0'+data.seconds:data.seconds));
                    },
                    onEnd: function(){
                        location.reload();
                    }
                }).start();
                $(".sales-timer").show();

            }else{
                $(".sales-timer").remove();
            }
        },

        // 轮播渲染
        renderSlide: function (data) {
            var $target = $('#slides');
            var tpl = $('#tpl-slides').html();
            $target.html(_.template(tpl)({
                itemImageList: data,
                w:winW
            }));

            // slide show
            this.slider = new lib.Slider('.slider-box',{
                loop : true,
                play : true,
                trigger : '.slider-status'
            });
            lib.lazyload.trigger();
        },

        // 商品信息
        renderItems: function (item) {
            var that = this, arr = [],
                $target = $('.pro-info'),
                tpl = $('#tpl-item').html();
            if(item.item_extra_info) {
                var rule = item.item_extra_info.grant_rule ? item.item_extra_info.grant_rule.rule_module_list : 0;
                for(var i= 0,len=rule.length; i<len; i++) {
                    arr.push(rule[i]);
                }
                if(rule != 0) {
                    arr.reverse();
                    item.item_extra_info.grant_rule.rule_module_list = arr;
                }
            }
            // 无折扣
            if(that.min_promotion_price == that.min_market_price && that.max_promotion_price== that.max_market_price){
                $target.append(_.template(tpl)({
                    item: item,
                    isShow:false,
                    min_promotion_price:that.min_promotion_price,
                    max_promotion_price:that.max_promotion_price
                }));
            // 有折扣
            }else{
                var discount = (that.min_discount<0.1)?0.1:(that.min_discount>9.9)?9.9:that.min_discount;
                $target.prepend(_.template(tpl)({
                    item: item,
                    isShow:true,
                    min_discount:discount,
                    min_promotion_price:that.min_promotion_price,
                    max_promotion_price:that.max_promotion_price,
                    min_market_price:that.min_market_price,
                    max_market_price:that.max_market_price
                }));
            }
            that.addActivityEvent();
        },

        // 渲染门店信息
        renderStore: function(data){
            var $target = $("#store");
            var tpl = $("#tpl-store").html();
            $target.html(_.template(tpl)({
                support: data
            }));
        },

        // 商品优惠信息
        renderDiscountInfo: function(suit_list, barter_list, cut_list){
            var $target = $(".preferential-list");
            var tpl = $("#tpl-preferential").html();
            $target.html(_.template(tpl)({
                suit_list: suit_list,
                barter_list:barter_list,
                cut_list:cut_list
            }));

            lib.storage.set('suit_list', suit_list);

            $('.box-fold').on('click', function(){
                var $boxBody = $(this).closest('.box').find('.box-body');
                if($boxBody.hasClass('fold-close')){
                    $boxBody.removeClass('fold-close');
                }else{
                    $boxBody.addClass('fold-close');
                }
            });
        },

        // 商品参数
        renderParam:function(data){
            var $target = $("#param");
            var tpl = $("#tpl-param").html();
            $target.append(_.template(tpl)({
                paramList: data
            }));
        },

        // 专场
        renderBrands:function(data,id){
            var that = this;
            var $target = $('#brands');
            var tpl = $('#tpl-brands').html();
            $target.append(_.template(tpl)({
                brand: data,
                bid: id
            }));
        },

        // 加载评论
        renderComment: function(isAlone){
            var that = this;
            that.add_comment = true;
            that.isAlone = isAlone;

            if (that.isAjax) {
                return;
            }
            that.isAjax = true;
            lib.api.get({
                api: 'item/comment/list',
                data: {
                    item_uid: that.item_uid,
                    offset: that.page*20,
                    count: 20
                },
                //mock:{
                //    path:'./data/comment-list.json'
                //},
                success: function (data) {
                    var list = data.data.comment_list;
                    if(Array.isArray(list) && list.length){
                        $('.no-comment').hide();
                        var tpl = $("#tpl-comment").html();
                        var $target = $('.comment-lists');

                        if(isAlone){
                            $('.body-content').css('background','#fff').html('<div id="comment" class="pro pro-comment"><div class="comment-counts"><span class="active">全部(<i>0</i>)</span><span data-id="5">好评(<i>0</i>)</span><span data-id="3">中评(<i>0</i>)</span><span data-id="1">差评(<i>0</i>)</span> </div> <div class="no-comment"> <div class="comment-icon"></div><p class="tips">商品待评论~</p> </div> <div class="comment-lists"></div> </div>');
                            $('#comment').show();
                            $target = $('.body-content > .pro-comment .comment-lists');
                        }

                        $('.comment-counts span').eq(0).find('i').text(data.data.total_count);
                        $('.comment-counts span').eq(1).find('i').text(data.data.good_comment_number);
                        $('.comment-counts span').eq(2).find('i').text(data.data.mid_comment_number);
                        $('.comment-counts span').eq(3).find('i').text(data.data.bad_comment_number);

                        if(that.page == 0){
                            $target.html(_.template(tpl)({
                                commentList: list
                            }));
                        }else{
                            $target.append(_.template(tpl)({
                                commentList: list
                            }));
                        }

                        that.page++;
                        !that.infiniteScroll.started && that.infiniteScroll.start();

                        //展示好中差评的筛选
                        $('.comment-counts').show();
                        $('.comment-lists').show();

                        lib.lazyload.trigger();

                        //筛选过滤事件监听
                        $('.comment-counts span').on('click', function(){
                            $(this).addClass('active').siblings().removeClass('active');

                            that.filter = true;
                            that.add_comment = false;
                            that.filter_index = $(this).index();
                            that.filter_score = $(this).attr('data-id');
                            that.filter_target = $('.comment-lists');

                            if(that.filter_index == 0){
                                that.filter = false;
                                that.page = 0;
                                if(that.isAlone){
                                    that.renderComment(true);
                                }else{
                                    that.renderComment();
                                }
                            }else{
                                that.page_filter = [0,0,0];
                                that.renderFilterComment(that.filter_index-1,that.filter_score,that.filter_target);
                            }
                        });
                    }else{
                        if(isAlone && that.page == 0) {
                            $('.body-content').html('<div class="no-comment" style="display: block;"><div class="comment-icon"></div><p class="tips">商品待评论~</p></div>');
                        }else if(that.page == 0){
                            $('#comment').html('<div class="no-comment" style="display: block;"><div class="comment-icon"></div><p class="tips">商品待评论~</p></div>');
                        }
                        that.isEnd = true;
                        that.add_comment = false;
                    }
                },
                error: function (data) {
                    $('.comment-counts').hide();
                    $('.comment-lists').hide();
                    $('.no-comment').show();
                },
                complete: function () {
                    that.isAjax = false;
                }
            })
        },

        renderFilterComment: function(index,score,target){
            var that = this;
            if (that.isFilterAjax) {
                return;
            }
            that.isFilterAjax = true;
            lib.api.get({
                api: 'item/comment/grade',
                data: {
                    item_uid: that.item_uid,
                    score: score,
                    offset: that.page_filter[index]*20,
                    count: 20
                },
                //mock:{
                //    path:'./data/comment-good.json'
                //},
                success: function (data) {
                    //console.log(data);
                    var list = data.data.comment_grade;
                    if(Array.isArray(list) && list.length){
                        $('.no-comment').hide();
                        $('.comment-lists').show();

                        var tpl = $("#tpl-comment").html();
                        var $target = target;

                        $target.html(_.template(tpl)({
                            commentList: list
                        }));

                        that.page_filter[index]++;
                        !that.infiniteScroll.started && that.infiniteScroll.start();

                    }else{
                        if(Array.isArray(list) && that.page_filter[index] == 0){
                            $('.no-comment').show().find('.tips').text('商品暂无该类评论');
                            $('.comment-lists').hide();
                        }else{
                            that.isEnd = true;
                            that.filter = false;
                        }
                    }
                    lib.lazyload.trigger();
                },
                error: function (data) {
                    console.log(data);
                    $('body').html('评论列表');
                },
                complete: function () {
                    that.isFilterAjax = false;
                }
            })
        },

        // tab切换
        contentTab: function(){
            var that = this;
            var triggerImg = false;
            $(".middle-top li").on("click",function(){
                var po = $(this).find("span").attr("po");
                switch (po){
                    case '2':
                        that.renderComment();//加载评论

                        $(".pro-detail").hide();
                        $(".pro-param").hide();
                        $(".pro-comment").show();
                        if(!triggerImg){
                            lib.lazyload.trigger();
                        }
                        triggerImg = true;
                        break;
                    default :
                        $(".pro-detail").show();
                        $(".pro-param").hide();
                        $(".pro-comment").hide();
                }
                $(".middle-top span").removeClass("hover");
                $(this).find("span").addClass("hover");
            })
        },

        // 添加到购物车
        addToCart: function(){
            var that = this;

            if(!that.checkStock()){
                return;
            }

            //console.log(that.selectItemSkuUid,that.item_number);
            if(that.isAddAjax){
                that.isAddAjax = true;
            }

            // 获取已选服务
            var service_list = [];
            var inputs = $('input[type="checkbox"]').filter('.checked');
            for(var i=0;i<inputs.length;i++){
                service_list[i] = {
                    "service_uid": $(inputs[i]).closest('.sku-service').attr('data-service_uid')
                };
            }

            var data = {
                sku_uid: that.selectItemSkuUid,
                number: that.item_number
            };
            if(service_list && service_list.length){
                data.service_list = JSON.stringify(service_list);
            }

            lib.api.post({
                needLogin:true,
                api:'trade/cart/item/add',
                data: data,
                success: function(data){
                    lib.notification.simple("添加成功",'',1000);
                    that.num = (lib.storage.get('cartNum') != undefined || lib.storage.get('cartNum') != 'undefined')?lib.storage.get('cartNum')+that.item_number:0;
                    if(that.num){
                        lib.storage.set('cartNum',that.num);
                        $('.cart-num').html(that.num > 0 ? that.num : '');
                    }
                },
                error: function(data){
                    console.log(data);
                    lib.notification.simple(data.msg,'',1000);
                },
                complete: function(){
                    $(".sku-dialog").css("-webkit-transform","translateY(100%)");
                    $("body").find('.mask').hide();
                    that.isAddAjax = false;
                }
            });
        },

        // 立即购买
        pay:function(){
            var that = this;
            if(!that.checkStock()){
                return;
            }

            if(!lib.login.isLogin()){
                lib.login.goLogin();
            }else{
                if(that.isPayAjax){
                    return;
                }

                var service_list = [];
                var inputs = $('input[type="checkbox"]').filter('.checked');
                for(var i=0;i<inputs.length;i++){
                    service_list.push({service_uid: $(inputs[i]).closest('.sku-service').attr('data-service_uid')});
                    //service_list[i] = $(inputs[i]).closest('.sku-service').attr('data-service_uid');
                }
                that.selectPro = [{
                    "sku_uid": that.selectItemSkuUid,
                    "item_uid": that.item_uid,
                    "item_type": that.item_type,
                    "number": that.item_number,
                    "service_list": service_list
                }];
                lib.storage.set('products',JSON.stringify(that.selectPro));
                lib.storage.set('sourceType',2);
                lib.storage.rm('selectedCouponInfo');
                that.goToConfirmOrder();
            }
        },

        // 检查库存
        checkStock: function(){
            var that = this;
            var isStock = true;

            if(!that.itemSkuList){
               return;
            }

            for(var i=0;i<that.itemSkuList.length;i++){
                if(that.itemSkuList[i].sku_uid == that.selectItemSkuUid && that.itemSkuList[i].stock_num<1){
                    isStock = false;
                    lib.notification.simple("库存不足",'',1000);
                }
            }
            return isStock;
        },

        // 收藏
        addFav: function(obj){
            var that = this;
            if(that.isFavAjax){
                return;
            }
            that.isFavAjax = true;
            lib.api.post({
                needLogin:true,
                api:'item/collection/add',
                data:{
                    item_uid_list:JSON.stringify(that.itemsList)
                },
                success: function(data){
                    //console.log(data);
                    $(obj).addClass('selected');
                    lib.notification.simple("添加收藏成功",'',1000);
                },
                error: function(data){
                    console.log(data.msg);
                },
                complete: function(){
                    that.isFavAjax = false;
                }
            });
        },

        // 取消收藏
        rmFav: function(obj){
            var that = this;
            if(that.isFavRmAjax){
                return;
            }
            that.isFavRmAjax = true;
            lib.api.post({
                needLogin:true,
                api:'item/collection/delete',
                data:{
                    item_uid_list:JSON.stringify(that.itemsList)
                },
                success: function(data){
                    //console.log(data);
                    $(obj).removeClass('selected');
                    lib.notification.simple("取消收藏成功",'',1000);
                },
                error: function(data){
                    console.log(data.msg);
                },
                complete: function(){
                    that.isFavRmAjax = false;
                }
            });
        },

        setHistory: function(data){
            console.log(data);
            var historyLists = lib.storage.get('historyLists')?lib.storage.get('historyLists'):{};

            historyLists[data.item_uid] = historyLists[data.item_uid]?historyLists[data.item_uid]:{};
            historyLists[data.item_uid] = {
                icon_url:data.icon_url,
                item_name:data.item_name,
                item_uid:data.item_uid,
                item_price:data.promotion_price,
                timestamp:Math.floor(Date.now()/1000)
            };

            lib.storage.set('historyLists',historyLists);
        },

        // sku相关处理
        handleSku: function(data){
            var that = this;
            var pro_sotck_num = 0;
            var skuProList = data.data.item.sku_property_list;

            //sku属性列表的处理
            var af_skuProList = {};
            for(var i=0;i<skuProList.length;i++){
                af_skuProList[skuProList[i].name] = af_skuProList[skuProList[i].name]?af_skuProList[skuProList[i].name]:[];
                af_skuProList[skuProList[i].name].push(skuProList[i].value);
            }
            //console.log(af_skuProList,'hha');

            var len = 0;
            for(var it in af_skuProList){
                $('.sku-info').append('<li data-id="'+len+'"><span class="text">'+it+'：</span><p></p></li>');
                var _data = af_skuProList[it];
                for(var k=0;k<_data.length;k++){
                    if(k){
                        $('.sku-info li[data-id="'+len+'"] p').append('<span>、'+_data[k]+'</span>');
                    }else{
                        $('.sku-info li[data-id="'+len+'"] p').append('<span>'+_data[k]+'</span>');
                    }
                }
                len++;
            }

            //sku对应的商品的整理
            var len = this.itemSkuList.length;
            if(len != 0) {
                var min_promotion_price = max_promotion_price = this.itemSkuList[0].promotion_price, min_market_price = max_market_price = this.itemSkuList[0].market_price;
                var min_discount = 10.0;
                var item_arr = {};
                for (var i = 0; i < len; i++) {
                    var keyValue = {};
                    pro_sotck_num += this.itemSkuList[i].stock_num;
                    var skuList = this.itemSkuList[i].sku_property_list;
                    for (var j = 0; j < skuList.length; j++) {
                        var skuItem = skuList[j];
                        keyValue[skuItem.name] = skuItem.value;
                    }
                    item_arr[this.itemSkuList[i].sku_uid] = keyValue;
                    that.min_promotion_price = min_promotion_price = min_promotion_price < this.itemSkuList[i].promotion_price ? min_promotion_price : this.itemSkuList[i].promotion_price;
                    that.min_market_price = min_market_price = min_market_price < this.itemSkuList[i].market_price ? min_market_price : this.itemSkuList[i].market_price;
                    that.max_promotion_price = max_promotion_price = max_promotion_price > this.itemSkuList[i].promotion_price ? max_promotion_price : this.itemSkuList[i].promotion_price;
                    that.max_market_price = max_market_price = max_market_price > this.itemSkuList[i].market_price ? max_market_price : this.itemSkuList[i].market_price;
                    that.min_discount = min_discount = min_discount < 10 * (this.itemSkuList[i].promotion_price / this.itemSkuList[i].market_price) ? min_discount : 10 * (this.itemSkuList[i].promotion_price / this.itemSkuList[i].market_price);
                }
                that.pro_stock_num = pro_sotck_num;
                if(pro_sotck_num){
                    $('.others').prepend('<li class="stock_num"><span class="text">剩余：</span><p>'+pro_sotck_num+'件</p></li>');
                }
                if(that.higo_mark) {
                    var sui = that.higo_extra_info.tax_rate*100+'%';
                    $('.other-info .sui').append('<li>税率：'+sui+'</li>');
                }

                $('.current').html(HDL.price(that.min_promotion_price)+'~'+HDL.price(that.max_promotion_price));
                $('.old').html(HDL.price(that.min_market_price)+'~'+HDL.price(that.max_market_price));

                if(max_market_price == min_market_price && min_promotion_price == max_promotion_price && min_market_price==max_promotion_price){
                    //SKU弹层
                    $('.current').html(HDL.price(that.min_promotion_price));
                    $('.old-price').hide();

                    //商品
                    $('.current_price').html(HDL.price(that.min_promotion_price));
                    $('.origin').hide();
                }else if(max_market_price == min_market_price && min_promotion_price == max_promotion_price){
                    //SKU弹层
                    $('.current').html(HDL.price(that.min_promotion_price));
                    $('.old').html(HDL.price(that.min_market_price));

                    //商品
                    $('.current_price').html(HDL.price(that.min_promotion_price));
                    $('.origin_price').html(HDL.price(that.min_market_price));
                }else if(min_promotion_price == min_market_price && max_market_price == max_promotion_price){
                    //SKU弹层
                    $('.old-price').hide();

                    //商品
                    $('.origin').hide();
                }else{
                    if(max_market_price == min_market_price){
                        //SKU弹层
                        $('.old').html(HDL.price(that.min_market_price));

                        //商品
                        $('.origin_price').html(HDL.price(that.min_market_price));
                    }
                    if(min_promotion_price == max_promotion_price){
                        //SKU弹层
                        $('.current').html(HDL.price(that.min_promotion_price));

                        //商品
                        $('.current_price').html(HDL.price(that.min_promotion_price));
                    }
                }
            }
            this.renderSku(af_skuProList,item_arr);
        },

        // sku渲染
        renderSku: function(skuList,itemList){
            var that = this, obj = [];
            for(var i in skuList) {
                $.each(skuList[i], function(j, item) {
                    for(var k in itemList) {
                        $.each(itemList[k], function(c, val) {
                            if(val == item) {
                                obj[j] = k;
                            }
                            return false;
                        });
                    }
                });
                break;
            }
            var $target = $('#select-content-box');
            var tpl = $('#tpl-sku-select').html();
            $target.prepend(_.template(tpl)({
                skuList: skuList,
                itemList:itemList,
                obj: obj
            }));

            $('.sku-title').html(that.sku_title);
            //$('.sku-item-info .item-img').css('background-image',that.icon_url);
            $('.item-img').css('backgroundImage','url('+that.icon_url+')');

            this.skuDialog = new lib.Dialog({
                boxClass:'#sku-box',
                triggerClass: '.sku-trigger',
                triggerInnerClass:'.sku-choose',
                hideClass:'.sku-close',
                onShow:function(){
                    var dialogIn = setTimeout(function () {
                        $(".sku-dialog").css("-webkit-transform","translateY(0%)");
                        clearTimeout(dialogIn);
                    }, 100);

                    $("body").find('.mask').show();
                    $(".sku-dialog").show();
                    if(that.higo_mark) {
                        var sui = that.higo_extra_info.tax_rate*100+'%';
                        $('.suiRateNum').text(sui);
                        $('.suiRate').show();
                    }
                    $('.sku-confirm').html('<a id="confirm" class="confirm">确认</a>');

                    that.renderSkuInfo();
                    if(that.higo_mark) {
                        that.bind_add_minus();
                    }

                    //确定
                    $('#confirm').on('click', function(){
                        if(!that.selectItemSkuUid){
                            //$(".sku-dialog").css("-webkit-transform","translateY(100%)");
                            //$("body").find('.mask').hide();
                            lib.notification.simple("没有选中属性",'',1000);
                            return;
                        }
                        that.item_number = $('.J_InputNum').attr('valueAsNumber');
                        if($('#sku-box').attr('control-type')=='add') {
                            that.addToCart();
                        }else{
                            if(that.service_type_list.length > 0) {
                                var container = [], service = [], $main = $('#sku-content .sku-service-wrap .sku-service-label .sku-service'), $check = $main.find('.service-check input.service-check-item'), $info;
                                for (var i in $check) {
                                    if ($check.eq(i).hasClass('checked')) {
                                        $info = $check.eq(i).closest('.sku-service').find('.service-info');
                                        var obj = {};
                                        obj.service_uid = $main.data('service_uid');
                                        obj.service_name = $info.find('p').eq(1).text();
                                        obj.service_price = $info.find('p').eq(0).text();
                                        service.push(obj);
                                    }
                                }
                                var object = {};
                                object.tag = $('#select-content-box .sku-item-label span.selected').data('sku-uid');
                                object.value = service;
                                container.push(object);
                                lib.storage.set('serviceExtra', JSON.stringify(container));
                            } else {
                                lib.storage.set('serviceExtra', JSON.stringify([]));
                            }
                            that.pay();
                        }
                    });
                },
                onShowAll: function(){
                    var dialogAllIn = setTimeout(function () {
                        $(".sku-dialog").css("-webkit-transform","translateY(0%)");
                        clearTimeout(dialogAllIn);
                    }, 100);

                    $("body").find('.mask').show();
                    $(".sku-dialog").show();
                    if(that.higo_mark) {
                        var sui = that.higo_extra_info.tax_rate*100+'%';
                        $('.suiRateNum').text(sui);
                        $('.suiRate').show();
                    }
                    $('.sku-confirm').html('<div class="left"><a class="addTo">加入购物车</a></div><div class="right"><a class="buy">立即购买</a></div>');

                    that.renderSkuInfo();

                    $('.addTo').on('click', function(){
                        if($('.sku-dialog').hasClass('soldout')){
                            return;
                        }
                        that.item_number = $('.J_InputNum').attr('valueAsNumber');
                        if(that.selectItemSkuUid){
                            that.addToCart();
                        }else{
                            $(".sku-dialog").css("-webkit-transform","translateY(100%)");
                            $("body").find('.mask').hide();
                            lib.notification.simple("没有选中属性",'',1000);
                        }
                    });

                    $('.buy').on('click', function(){
                        if($('.sku-dialog').hasClass('soldout')){
                            return;
                        }
                        that.item_number = $('.J_InputNum').attr('valueAsNumber');
                        if(that.selectItemSkuUid){
                            that.pay();
                        }else{
                            $(".sku-dialog").css("-webkit-transform","translateY(100%)");
                            $("body").find('.mask').hide();
                            lib.notification.simple("没有选中属性",'',1000);
                        }
                    });
                },
                onHide:function(){
                    $(".sku-dialog").css("-webkit-transform","translateY(100%)");
                    $("body").find('.mask').hide();
                }
            });

            that.getSkuItem(itemList);

            //取消
            $(".sku-cancel").on('click', function () {
                $(".sku-dialog").css("-webkit-transform","translateY(100%)");
                var dialogOut = setTimeout(function () {
                    //$("#sku-dialog").hide();
                    $("body").find('.mask').hide();
                    clearTimeout(dialogOut);
                }, 300);
            });

            /*
            * 这里主要是对商品的每单最大购买数、库存以及用户级别的限购所影响的购买数量的计算
            * 判断比较乱，因为考虑到几种特殊情况：
            * 1、库存<每单最大购买数<用户限购数
            * 2、没有用户限购，库存<每单最大购买数
            * 3、没有每单最大购买数，库存<用户限购数
            * */
            var max_num = 0,min_num=0;
            if(that.limit_buy_count && that.sale_max_num && that.stock_num){
                var min_max = Math.min(that.limit_buy_count,that.sale_max_num);
                max_num = Math.min(min_max,that.stock_num);
            }else if(that.sale_max_num && that.stock_num){
                max_num = Math.min(that.stock_num,that.sale_max_num);
            }else if(that.limit_buy_count && that.stock_num){
                max_num = Math.min(that.stock_num,that.limit_buy_count);
            }else {
                max_num = that.limit_buy_count ? that.limit_buy_count : that.sale_max_num ? that.sale_max_num : that.stock_num ? that.stock_num : 99999;
            }

            if(that.sale_min_num && that.limit_buy_count){
                var _min_num = Math.min(that.sale_min_num,that.limit_buy_count);
                min_num = Math.min(_min_num,that.stock_num);
            }else if(that.sale_min_num){
                min_num = Math.min(that.sale_min_num,that.stock_num);
            }else{
                min_num = 1;
            }

            that.number = new ctrl.number({
                el: '#J_Num1',
                step: 1,
                quantity: that.sale_min_num?that.sale_min_num:1,
                min: min_num,
                max: max_num
            });

            //sku选择
            $(".sku-select span").click(function(){
                var _that = this;
                if($(this).hasClass('selected')){return;}

                $(this).addClass('selected').siblings().removeClass('selected');
                that.getSkuItem(itemList);
                that.renderSkuInfo();

                that.number = new ctrl.number({
                    el: '#J_Num1',
                    step: 1,
                    quantity: that.sale_min_num?that.sale_min_num:1,
                    min: that.sale_min_num?that.sale_min_num:1,
                    max: max_num>Number($('.buy-number').attr('stock_num'))?Number($('.buy-number').attr('stock_num')):max_num
                });

                if(that.higo_mark) {
                    that.bind_add_minus();
                }
            });
        },

        bind_add_minus: function() {
            $('#J_Num1 .J_Add').on('click', function() {
                var sum = $('.current').text(),
                    num = $('.J_InputNum.input-num').val(),
                    total = Number(sum)*Number(num);
                if(total > 1000) {
                     var biz_info = lib.storage.get('biz_info');
                    $('.sui-kuang').show();
                    $('.sui-kuang').text(biz_info.higo_info.item_limit_msg);
                    $('#none').remove();
                    var $clone = $('#confirm').clone();
                    $clone.attr('id', 'none');
                    $clone.css({'background-color': '#999', 'border': '1px solid #999'});
                    $('#confirm').after($clone);
                    $('#confirm').hide();
                    $clone.show();
                }
            });
            $('#J_Num1 .J_Minus').on('click', function() {
                var sum = $('.current').text(),
                    num = $('.J_InputNum.input-num').val(),
                    total = Number(sum)*Number(num);
                if(total <= 1000 || Number(num) == 1) {
                    $('.sui-kuang').hide();
                    $('#none').remove();
                    $('#confirm').show();
                }
            });
        },

        // 渲染增值服务
        renderValAddService: function(data){
            var $target = $('.sku-service-box');
            var tpl = $('#tpl-sku-service').html();
            $target.append(_.template(tpl)({
                serviceList: data
            }));

            $('.service-check-item').on('click', function(){
                if($(this).hasClass('checked')){
                    $(this).removeClass('checked');
                }else{
                    $(this).closest('.sku-service').siblings().find('input').removeClass('checked');
                    $(this).addClass('checked');
                }
            });
        },

        // 商品信息展示的多sku入口
        renderSkuInfo: function(){
            //选中sku显示
            var selected_sku_info = '';
            $('.sku-select .selected').forEach(function(item){
                selected_sku_info += '  '+$(item).attr('data-value');
            });

            if(this.selectItemSkuUid){
                $('.choose-tips').text('已选择');
                $('.choosed').html('"'+selected_sku_info.slice(2)+'"');
            }
        },

        // 通过属性组合获取商品
        getSkuItem: function(itemList){
            var that = this;
            var sku_arr = {};
            $('.sku-content .selected').forEach(function(item,i){
                var sName = $(item).closest('.sku-select').find('.name').attr('data-key');
                sku_arr[sName] = sku_arr[sName]?sku_arr[sName]:[];
                sku_arr[sName] = $(item).attr('data-value');
            });

            //查找选定sku_uid
            for(var key in itemList){
                var newItemList = itemList[key];
                if(compareObj(newItemList,sku_arr)){
                    that.selectItemSkuUid = key;
                }
            }

            //通过sku_uid获取商品信息
            var len = that.itemSkuList.length;
            for(var i = 0;i<len;i++){
                that.stock_num += that.itemSkuList[i].stock_num;
                if(that.itemSkuList[i].sku_uid == that.selectItemSkuUid){
                    if(that.itemSkuList[i].image_url){
                        $('.item-img').css('backgroundImage','url('+that.itemSkuList[i].image_url+')');
                    }

                    if(that.itemSkuList[i].promotion_price){
                        $('.current').html(HDL.price(that.itemSkuList[i].promotion_price));
                        $('.current_price').html(HDL.price(that.itemSkuList[i].promotion_price));
                        that.item_promotion_price = that.itemSkuList[i].promotion_price;

                    }
                    if(that.itemSkuList[i].market_price ){
                        $('.old').html(HDL.price(that.itemSkuList[i].market_price));
                        $('.origin_price').html(HDL.price(that.itemSkuList[i].market_price));

                    }
                    $('.buy-number').attr('stock_num',that.itemSkuList[i].stock_num);
                }
            }
        },


        // 处理商品活动信息结构
        // todo
        handleDiscountInfo: function (data) {
            var that = this;
            var cut_list = [], barter_list = [], suit_list = [];

            // 营销活动
            for(var s=0;s<data.length;s++){
                var tool_code = data[s].market_activity.tool_code;
                if(tool_code == 'ReachMultipleReduceTool'){                                    //满减送活动
                    cut_list[cut_list.length] = data[s];
                }else if(tool_code == 'BarterTool'){                                           //换购
                    barter_list[barter_list.length] = data[s];
                }else if(tool_code == 'SuitTool'){                                             //套装
                    suit_list[suit_list.length] = data[s];
                }
            }

            that.renderDiscountInfo(suit_list, barter_list, cut_list);
        },

        /**
         * 以下为活动部分涉及的方法
         * todo 待联调部分
         */
        // 活动事件监听
        addActivityEvent: function(){
            var that = this;
            var titleText,
                content;

            $('.rule-fold').on('click', function(){
                if($(this).hasClass('fold-open')){
                    $(this).removeClass('fold-open').addClass('fold-close');
                    $('.activity-desc .to-fold').show();
                }else{
                    $(this).removeClass('fold-close').addClass('fold-open');
                    $('.activity-desc .to-fold').hide();
                }
            });

            $('.rule-btn').on('click', function(){
                if(that.item_type==15){             // 竞拍
                    titleText = '拍卖规则';

                    if(that.auction_type==1){       //升价拍
                        content = [
                            '<p>升价拍商品价格竞买者自由叫价，每次叫价幅度固定，在活动结束前，叫价最高者获得该商品的支付权。<br/>',
                            '部分拍卖需要支付保证金，最后获得支付权的竞买者，只需支付尾款即可，如取消支付，保证金不予退还，支付时间30分钟。<br/>',
                            '未获得支付权的竞买者，保证金原路返还。</p>',
                            '<p>延时周期说明：在拍卖结束前一个延时周期时，如有用户出价，拍卖时间自动延长一个延时周期，直至一个延时周期无人出价，活动结束。<br/>',
                            '加价频率为5S加价一次。</p>'

                        ].join('');
                    }else{                          //降价拍
                        content = [
                            '<p>降价拍商品价格由高到低依次递减，直至竞买人以自己可承受价格抢单支付成功，活动结束。</p>',
                            '<p>每位竞买人，均有依次抢拍资格，抢拍以最先支付成功者获得，否则是做放弃本次抢拍权利。</p>'
                        ].join('');
                    }
                }

                if(that.item_type==13){            //秒杀
                    titleText = '秒杀规则';
                    content = [
                        '<p>活动开始后，买家才能参与活动。买家下单后，需在15分钟内完成支付，超时订单将自动取消。</p>',
                        '<p>订单取消后，库存释放，等待中的买家可继续参与秒杀。商品售罄，活动自动结束。</p>'
                    ].join('');
                }

                if(that.item_type==14){            //团购
                    titleText = '团购规则';
                    content = [
                        '<p>',
                        '买家参与团购，需在15分钟内完成支付，否则订单自动取消；<br/>',
                        '返现金额通过余额的形式返在活动结束后自动至用户账户，发放余额可做提现。',
                        '</p>'
                    ].join('');
                }

                ctrl.modal.alert({
                    titleText: titleText,
                    btnText: '知道了',
                    content: content,
                    color: that.item_type==1?'#ff4b55':'#ff4b55',
                    mask: true,
                    callback: function(){
                        this.hide();
                    }
                }).show();
            });

            $('.btn-buy').on('click', function(){
                if(!$(this).hasClass('active') || ($(this).text() == '秒杀准备')){return;}
                var $self = $(this);

                if(that.item_type == 15 && that.auction_type==1){
                    if(that.lifecycle == 2){
                        titleText = '保证金';
                        content = [
                            '<p>参与该拍卖活动，需要预先支付'+ HDL.price(that.deposit) +'元保证金。</p>',
                            '<p>如未获得最终支付权，保证金原路返回。</p>',
                            '<p>如拍卖成功，只需支付剩余部分尾款即可。</p>'
                        ].join('');
                        var btContent = [
                            '<span class="deposit-value">'+ HDL.price(that.deposit) +'</span>',
                            '<a href="pay-center.html?&item_uid=' + that.item_uid + '&pay_amount='+that.deposit+'" class="toPayDeposit">去支付</a>'
                        ].join('');

                        ctrl.modal.alert({
                            titleText: titleText,
                            content: content,
                            color: '#ff4b55',
                            bottomCnt: btContent,
                            mask: true,
                            callback: function(){
                                this.hide();
                            }
                        }).show();
                    }else if(that.lifecycle == 3){
                        that.refreshAuction();
                    }else if(that.lifecycle == 11){
                        that.refreshAuction(function () {
                            that.auctionRisingBid();
                        })
                    }else{
                        that.goToConfirmOrder();
                    }
                }else if(that.item_type == 15 && that.auction_type==2){
                    if(that.lifecycle == 2){
                        that.auctionCutBid();
                    }else if(that.lifecycle==3){
                        that.refreshAuction();
                    }else if (that.lifecycle==12) {
                        that.goToConfirmOrder();
                    }
                }else if(that.item_type == 14){//团购
                    if(that.lifecycle == 2){
                        that.groupBuy();
                    }else if(that.lifecycle == 3){
                        location.reload();
                    }
                }else if(that.item_type == 13){//秒杀
                    if(that.lifecycle == 2){
                        $self.text('秒杀中...');
                        that.seckillApply();
                    }else if(that.lifecycle == 3){
                        lib.notification.simple('温馨提示：请耐心等待！其他用户正在付款中，如15分钟内未成功付款，活动继续', '', 1000);
                        that.refreshSeckill();
                    }else if(that.lifecycle == 11){
                        that.goToConfirmOrder();
                    }
                }
            });

            $('.sui li').on('click', function() {
                var biz_info = lib.storage.get('biz_info');
                if(!biz_info) {
                    that.getMallSet();
                } else {
                    that.popSui(biz_info);
                }
            });
        },
        popSui: function(biz_info) {
            var rate = this.higo_extra_info.tax_rate,
                fee = HDL.price(rate*this.wireless_price),
                max_fee = HDL.price(biz_info.higo_info.tax_free_amount),
                modal_content = '';
                console.log(Number(fee), Number(max_fee));
            if(Number(fee) <= Number(max_fee)) {
                modal_content += '<div class="top-info">关税=<del>&yen;'+fee+'</del><span>关税<=&yen;'+max_fee+'，免征哦</span></div>';
            } else {
                modal_content += '<div class="top-info">关税=&yen;'+fee+'</div>';
            }
            modal_content += '<div class="bottom-info">本商品使用税率为'+(rate*100+'%')+'，若订单总税额<='+max_fee+'元，则免征</div>';
            ctrl.modal.alert({
                titleText: '税费',
                btnText: '知道了',
                content: modal_content,
                color: '#ff4b55',
                mask: true,
                callback: function(){
                    this.hide();
                }
            }).show();
        },
        getMallSet: function() {
            var that = this;
            if(this.mallAjax) {return;}
            this.mallAjax = true;
            lib.api.get({
                api: 'auth/session_token/get',
                data: {},
                success: function(data) {
                    var biz_info = data.data.biz_info;
                    lib.storage.set('biz_info', biz_info);
                    that.popSui(biz_info);
                },
                error: function() {
                },
                complete: function() {
                    that.mallAjax = false;
                }
            });
        },

        /**
         * 根据不同的活动类型添加不同的类名
         * 保存活动开始结束时间以及系统时间 和 所处的生命周期
         * 竞拍（auction）：
         *     升价拍：1未开始 ->2 进行中（立即参与) -> 11可以叫价 ->12去支付 -> 4已结束
         *     降价拍：1未开始 ->2 进行中 (立即拿下) -> 3还有机会 ->12去支付 -> 4已结束
         * 秒杀（seckill）：
         *     1代表未开始，2代表进行中，3还有机会，4代表已结束， 11去结算
         * 团购（groupbuy）：
         *     1代表未开始，2代表进行中， 3还有机会, 4代表已结束
         */
        renderActivity: function(type, data){
            var that = this;

            var item_data = data.data.item;
            var item_type_name;
            that.data             = data;
            that.start_time       = Number(item_data.item_extra_info.start_time);
            that.end_time         = Number(item_data.item_extra_info.end_time);
            that.system_time      = Number(data.data.time);
            that.lifecycle        = item_data.item_extra_info.lifecycle;

            // 默认活动价
            var activityPrice = item_data.promotion_price;
            switch (type){
                case 15: // 竞拍
                    item_type_name        = 'auction';
                    that.auction_type     = item_data.item_extra_info.auction_type;
                    that.auction_uid      = item_data.item_extra_info.auction_uid;
                    that.starting_price = item_data.item_extra_info.starting_price; // 起拍价
                    that.end_price = item_data.item_extra_info.end_price;
                    that.current_price = item_data.item_extra_info.current_price;
                    that.price_unit   = item_data.item_extra_info.price_unit; // 降价幅度/加价幅度

                    // 1升价 2降价
                    if(that.auction_type  == 1){
                        that.end_price    = item_data.item_extra_info.end_price; // 升价拍保留价
                        that.deposit      = item_data.item_extra_info.deposit_price; // 保证金商品价格
                        that.deposit_data = {
                            "sku_uid":item_data.item_extra_info.sku_uid,
                            "number" :1,
                            "item_type":16
                        };
                        lib.storage.set('deposit_data', that.deposit_data);
                    }else{
                        that.next_cut_time= Number(item_data.item_extra_info.next_cut_time); // 距离下次降价的时间
                    }

                    activityPrice = item_data.item_extra_info.price; // 当前价格

                    // 渲染相关初始化数据
                    $('.act-old-price .RMB').html(HDL.price(that.starting_price));

                    that.auctionLifecycle();
                    break;
                case 14: // 团购
                    item_type_name        = 'groupbuy';
                    that.middleSeckill = true;
                    that.groupbuyLifecycle();
                    break;
                case 13: // 秒杀
                    item_type_name        = 'seckill';
                    that.middleSeckill = true;
                    that.seckillLifecycle(false, item_data.item_extra_info.stock_num);
                    break;
                default :
                    break;
            }

            that.renderActivityItem(item_type_name, activityPrice, item_data.market_price);
        },

        // 根据不同活动对应的类名显示对应的内容
        renderActivityItem: function(type, price, oldPrice){
            this.renderActivityPrice(price);
            var _oldPrice = HDL.price(oldPrice);
            $('.activity-timer').addClass(type+'-timer').css('opacity',1);
            $('.slider-box .slider-status').css('bottom','17.5%');
            $('.preferential').remove();
            $('.pro-footer').remove();
            if(type=='groupbuy'){
                $('.sold-number').show();
                $('.act-old-price .RMB').text(_oldPrice);
            }
            if(type=='seckill') {
                $('.act-old-price .RMB').text(_oldPrice);
            }
            if(type=='auction'){
                $('.act-old-price span:first-child').text('起拍价');
            }
        },

        // 显示活动价格，如果是小数，小数部分字体变小
        renderActivityPrice: function(price){
            var _price = HDL.price(price);
            if(parseInt(_price) == _price){
                $('.act-new-price').text(_price);
            }else{
                var float_string = Number(_price).toFixed(2).toString().split('.')[1];
                // $('.act-new-price').html(Math.floor(_price)+'<i>.'+ float_string +'</i>').addClass('last-smaller');
                $('.act-new-price').html(Math.floor(_price)+'<i>.'+ float_string +'</i>');
            }
        },

        // 活动倒计时
        activityTimer: function(sec){
            var that = this;
            if(!sec){
                $('.timer span').eq(0).text('00');
                $('.timer span').eq(2).text('00');
                $('.timer span').eq(4).text('00');
                $('.timer span').eq(6).text('0');
                return;
            }
            sec = Number(sec/1000).toFixed(1);
            that.at && that.at.stop();
            clearInterval(intervalCode);
            that.at = lib.countdown({
                endDate: "+"+sec.toString(),
                interval: 100,
                onUpdate: function(data){
                    var hours = data.days*24+data.hours;
                    var hour = hours<10?'0'+hours:hours;
                    var minutes = data.minutes<10?'0'+data.minutes:data.minutes;
                    var seconds = data.seconds<10?'0'+data.seconds:data.seconds;
                    var microSeconds = data.microSeconds;

                    //某些条件下会导致data.microSeconds不存在，故作此处理
                    if(!microSeconds) {
                        intervalCode = setInterval(function() {
                            if(countSeconds == 0) {
                                countSeconds = 10;   
                            }
                            countSeconds--;
                        }, 1);
                        if(hour == '00' && minutes == '00' && seconds == '00') {
                            console.log('结束');
                            clearInterval(intervalCode);
                            countSeconds = 0;
                        }
                    } else {
                        countSeconds = microSeconds+1;
                    }

                    $('.timer span').eq(0).text(hour);
                    $('.timer span').eq(2).text(minutes);
                    $('.timer span').eq(4).text(seconds);
                    $('.timer span').eq(6).text(microSeconds || countSeconds);
                },
                onEnd: function(){
                    //location.reload();

                    if(that.item_type == 15){
                        // 升 降价拍倒计时结束刷新轮询接口
                        that.handleTickEndForAuction();
                    }else if(that.item_type == 13){
                        // 秒杀倒计时结束刷新轮询接口
                        that.seckill = true;
                        that.handleTickEndForKill();
                    }else if(that.item_type == 14){
                        // 团购倒计时结束刷新当前页面
                        that.seckill = true;
                        if(that.lifecycle == 4){return;}
                        that.getPollingStatus();
                    }
                }
            }).start();
        },

        // 共同拥有的生命周期状态
        commonLifecycle: function (lifecycle, system_time) {
            var that = this;
            if (lifecycle == 1) {
                $('.timer-box .label').text('距开始仅剩');
                $('.activity-bottom .btn-buy').text('即将开始');
                that.gamestart = true;
                that.activityTimer(that.start_time - system_time);
            } else if (lifecycle == 4) {
                if (that.item_type == 15) {
                    $('.activity-bottom .btn-buy').text('拍卖结束');
                } else if (that.item_type == 14) {
                    $('.activity-bottom .btn-buy').text('团购结束');
                } else if (that.item_type == 13) {
                    $('.activity-bottom .btn-buy').text('秒杀结束');
                }
                $('.timer-box .label').text('已结束');
                if ($('.btn-buy').hasClass('active')) {
                    $('.btn-buy').removeClass('active');
                }
                that.reload_time = false;
                that.gameover = true;
                that.gamestart = false;
                that.at && that.at.stop();
                clearInterval(intervalCode);
                that.activityTimer(0);
            } else {
                that.gamestart = false;
            }
        },

        /**
         * 竞拍
         */
        // 竞拍接口刷新
        refreshAuction: function(cb){
            var that = this, tag = false;
            if(lib.login.isLogin()) {
                tag = true;
            }
            if(that.isAjaxAuctionRefresh){return;}
            that.isAjaxAuctionRefresh = true;
            lib.api.get({
                needLogin: tag,
                api: 'auction/status',
                data:{
                    auction_uid: that.auction_uid
                },
                //mock:{
                //    path:'./data/auction-refresh.json'
                //},
                success: function(data){
                    var auction_data   = data.data.auction;
                    that.reload_time   = data.data.time_interval;
                    that.act_price     = auction_data.price;
                    that.my_price     = auction_data.my_price;

                    // 更新价格
                    that.renderActivityPrice(auction_data.price);

                    //if(auction_data.lifecycle != that.lifecycle){
                        that.lifecycle_new = auction_data.lifecycle;
                        that.system_time_new = data.data.time;
                        that.next_cut_time_new = auction_data.next_cut_time;
                        that.auctionLifecycle(true);
                    //}else{
                    //    that.at && that.at.stop();
                    //    that.activityTimer(auction_data.next_cut_time);
                    //}

                    if(that.reload_time){
                        clearTimeout(that.load_timer);
                        that.load_timer = setTimeout(function(){
                            that.refreshAuction();
                        }, that.reload_time);
                    }

                    cb && cb.call(that);
                },
                error: function(){

                },
                complete: function(){
                    that.isAjaxAuctionRefresh = false;
                }
            });
        },

        // 竞拍生命周期及其相应显示的变化
        auctionLifecycle: function(isRefresh){
            var that = this;
            var lifecycle,system_time,next_cut_time;

            lifecycle      = isRefresh?that.lifecycle_new:that.lifecycle;
            system_time    = isRefresh?that.system_time_new:that.system_time;
            that.lifecycle = lifecycle;

            that.commonLifecycle(lifecycle, system_time);

            if (that.gameover || that.gamestart) return;
            if(that.auction_type == 1){                            // 加价拍
                if(lifecycle == 2){
                    $('.timer-box .label').text('距结束仅剩');
                    $('.activity-bottom .btn-buy').text('立即参与').addClass('active');
                    that.activityTimer(that.end_time-system_time);
                }else if(lifecycle == 11){
                    $('.timer-box .label').text('距结束仅剩');

                    that.my_price && $('.auction-deposit').text(HDL.pricetwo(that.my_price)).show();
                    $('.activity-bottom .btn-buy').text('立即叫价').addClass('active');
                    that.activityTimer(that.end_time-system_time);
                }else if(lifecycle == 12){
                    $('.timer-box .label').text('已结束');
                    $('.activity-bottom .btn-buy').text('去支付').addClass('active');
                    that.at && that.at.stop();
                    clearInterval(intervalCode);
                    that.activityTimer(0);
                    that.load_timer && clearTimeout(that.load_timer);
                }

                if(lifecycle == 2 || lifecycle == 11){
                    if(!isRefresh){
                        var latter = setTimeout(function(){
                            that.refreshAuction();
                            clearTimeout(latter);
                        }, 1000);
                    }
                }

                if(!$('.activity-bottom .auction').hasClass('auction-add')){
                    $('.activity-bottom .auction').addClass('auction-add');
                }

                $('.activity-bottom .auction').addClass('auction-add');
            }else{                                                 // 降价拍
                next_cut_time = isRefresh?that.next_cut_time_new:that.next_cut_time;
                that.activityTimer(next_cut_time);

                if(lifecycle == 2){
                    $('.activity-bottom .btn-buy').text('立即拿下').addClass('active');
                }else if(lifecycle == 3){
                    $('.activity-bottom .btn-buy').text('还有机会').addClass('active');
                }else if(lifecycle == 12){
                    $('.activity-bottom .btn-buy').text('去支付').addClass('active');
                    if(that.current_price != that.end_price) {
                        $('.timer-box .label').text('距下次降价仅剩');
                    }
                }

                if(lifecycle == 2 || lifecycle == 3){
                    $('.timer-box .label').text('距下次降价仅剩');
                    if(!isRefresh){
                        var interval = setTimeout(function(){
                            that.refreshAuction();
                            clearTimeout(interval);
                        }, 1000);
                    }
                }

                if($('.activity-bottom .auction').hasClass('auction-add')){
                    $('.activity-bottom .auction').removeClass('auction-add');
                }
                $('.auction-deposit').hide();
            }
        },

        // 升价竞拍出价
        auctionRisingBid: function(){
            var that = this;
            var act_price = that.act_price + that.price_unit;

            if(that.isAjaxRising){return;}
            that.isAjaxRising = true;
            lib.api.get({
                needLogin:true,
                api:'auction/rising/bid',
                data:{
                    "sku_uid": that.sku_uid,
                    "bid_price": act_price
                },
                //mock:{
                //    path:'./data/rising-bid.json'
                //},
                success: function(data){
                    console.log(data);
                    $('.auction-deposit').text(HDL.pricetwo(act_price)).show();
                },
                error: function(data){
                    lib.notification.simple(data.msg, 1000);
                },
                complete: function(){
                    that.isAjaxRising = false;
                }
            });
        },

        // 降价拍出价
        auctionCutBid: function(){
            var that = this;

            if(that.isAjaxCut){return;}
            that.isAjaxCut = true;
            lib.api.get({
                needLogin:true,
                api:'auction/cut/bid',
                data:{
                    "sku_uid": that.sku_uid
                },
                //mock:{
                //    path:'./data/cutbid.json'
                //},
                success: function(data){
                    console.log(data);
                    if(data.code == 10000){
                        that.goToConfirmOrder();
                    }
                },
                error: function(data){
                    lib.notification.simple(data.msg, 1000);
                },
                complete: function(){
                    that.isAjaxCut = false;
                }
            });
        },

        /**
         * 团购
         */
        // 团购生命周期
        groupbuyLifecycle: function(isRefresh){
            var that = this;
            var lifecycle, system_time, sold_number;
            lifecycle             = isRefresh?that.lifecycle_new:that.lifecycle;
            system_time           = isRefresh?that.system_time_new:that.system_time;
            that.lifecycle        = lifecycle;
            sold_number           = that.item_extra.sales || 0;
            $('.sold-number span').text(sold_number);
            that.commonLifecycle(that.lifecycle, system_time);

            if(that.lifecycle == 2){
                $('.activity-bottom .btn-buy').text('立即参团').addClass('active');
            }else if(that.lifecycle == 3){
                $('.activity-bottom .btn-buy').text('还有机会').addClass('active');
            }else if(that.lifecycle == 11){
                $('.timer-box .label').text('已结束');
                $('.activity-bottom .btn-buy').text('去支付').addClass('active');
                that.at && that.at.stop();
                clearInterval(intervalCode);
                that.activityTimer(0);
                that.load_timer && clearTimeout(that.load_timer);
            }

            if(that.lifecycle == 2 || that.lifecycle == 3){
                $('.timer-box .label').text('距结束仅剩');
                that.activityTimer(that.end_time-system_time);

                if(!isRefresh){
                    var latter = setTimeout(function(){
                        that.getPollingStatus();
                        clearTimeout(latter);
                    },3000);
                }
            }
        },

        //轮询请求团购状态
        getPollingStatus: function () {
            var that = this, tag = false;
            if(lib.login.isLogin()) {
                tag = true;
            }
            if(that.isAjaxPolling) {return;}
            that.isAjaxPolling = true;
            lib.api.get({
                needLogin: tag,
                api: 'groupbuy/status',
                data: {
                    'group_buy_uid': that.group_buy_uid || that.item_extra.group_buy_uid,
                    'sku_uid': that.item_sku_obj.sku_uid
                },
                success: function(data) {
                    var seckill_data   = data.data.group_buy;
                    that.reload_time   = data.data.time_interval*1000;
                    that.sold_number   = that.data.data.item.item_extra_info.sales || 0;
                    $('.sold-number span').text(that.sold_number);
                    if(that.seckill) {
                        that.seckill = false;
                        if(seckill_data.lifecycle == 1 || (seckill_data.lifecycle == 2 && that.lifecycle == 1)) {
                            $('.activity-bottom .btn-buy').text('立即参团').addClass('active');
                            $('.timer-box .label').text('距结束仅剩');
                            that.killSeckill = true;
                        } else {
                            $('.activity-bottom .btn-buy').text('团购结束');
                            $('.timer-box .label').text('已结束');
                            if ($('.btn-buy').hasClass('active')) {
                                $('.btn-buy').removeClass('active');
                            }
                            that.killSeckill = false;
                        }
                    }
                    if(seckill_data.lifecycle != that.lifecycle){
                        that.lifecycle_new = seckill_data.lifecycle;
                        that.system_time_new = data.data.current_time;
                        that.groupbuyLifecycle(true);
                        if(!that.killSeckill) {
                            that.commonLifecycle(4, 0);
                        }
                    }else{
                        that.at && that.at.stop();
                        clearInterval(intervalCode);
                        if(that.killSeckill || that.middleSeckill) {
                            that.activityTimer(that.end_time - data.data.current_time);
                        }
                    }
                    if(that.reload_time){
                        clearTimeout(that.load_timer);
                        that.load_timer = setTimeout(function(){
                            that.getPollingStatus();
                        }, that.reload_time);
                    }
                },
                error: function() {
                    lib.notification.simple(data.msg, 1000);
                },
                complete: function() {
                    that.isAjaxPolling = false;
                }
            });
        },
        // 团购
        groupBuy: function(){
            var that = this;
            if(that.isAjaxGroupbuy){return;}
            that.isAjaxGroupbuy = true;
            lib.api.post({
                needLogin:true,
                api:'groupbuy/apply',
                data:{
                    "group_buy_uid": that.item_extra.group_buy_uid,
                    "sku_uid": that.item_sku_obj.sku_uid
                },
                //mock:{
                //    path:'./data/groupbuy.json'
                //},
                success: function(data){
                    if(data.code == 10000){
                        that.goToConfirmOrder();
                    }
                },
                error: function(data){
                    lib.notification.simple(data.msg, 1000);
                },
                complete: function(){
                    that.isAjaxGroupbuy = false;
                }
            });
        },

        /**
         * 秒杀
         */
        // 秒杀生命周期
        seckillLifecycle: function(isRefresh, stock){
            var that = this;
            var lifecycle, system_time;
            lifecycle             = isRefresh?that.lifecycle_new:that.lifecycle;
            system_time           = isRefresh?that.system_time_new:that.system_time;
            //lifecycle             = stock==0?4:lifecycle;
            that.lifecycle        = lifecycle;
            that.secKillUid       = that.data.data.item.item_extra_info.seckill_uid;

            if (lifecycle != 11 && stock == 0) {
                lifecycle = 4;
            }
            that.commonLifecycle(lifecycle, system_time);
            if(lifecycle == 2){
                if($('.activity-bottom .btn-buy').text() != '秒杀中') {
                    $('.activity-bottom .btn-buy').text('立即秒杀').addClass('active');
                }
            }else if(lifecycle == 3){
                $('.activity-bottom .btn-buy').text('还有机会').addClass('active');
            }else if(lifecycle == 11){
                $('.activity-bottom .btn-buy').text('去支付').addClass('active');
            }

            if(lifecycle == 2 || lifecycle == 3 || lifecycle == 11){
                $('.timer-box .label').text('距结束仅剩');
                that.activityTimer(that.end_time - system_time);

                // todo 为什么要延迟
                if(!isRefresh){
                    var latter = setTimeout(function(){
                        that.refreshSeckill();
                        clearTimeout(latter);
                    },3000);
                }
            }
        },

        // 即将进入秒杀
        // 从未开始进入秒杀开始
        // 原因倒计时完毕，服务端存在延迟
        handleTickEndForKill: function () {
            var that = this;
            var refreshInterval = null;
            // 文案提示
            if (that.lifecycle == 1) {
                //console.log('倒计时结束', Date.now());
                $('.activity-bottom .btn-buy').text('秒杀准备').addClass('active');
                refreshInterval = 1;
            }

            // 轮询秒杀接口
            that.refreshSeckill(refreshInterval);
        },

        handleTickEndForAuction: function() {
            var that = this;
            // 文案提示
            if (that.lifecycle == 1) {
                //console.log('倒计时结束', Date.now());
                $('.activity-bottom .btn-buy').text('拍卖准备').addClass('active');
            }

            // 轮询秒杀接口
            that.refreshAuction();
        },

        // 秒杀刷新接口
        refreshSeckill: function(refreshInterval){
            var that = this, tag = false;
            if(lib.login.isLogin()) {
                tag = true;
            }
            if(that.isAjaxGroupRefresh){return;}
            that.isAjaxGroupRefresh = true;
            lib.api.get({
                needLogin: tag,
                api: 'seckill/status',
                data:{
                    "sku_uid": that.sku_uid,
                    "seckill_uid": that.secKillUid
                },
               /* mock:{
                    path:'./data/seckill-refresh.json'
                },*/
                success: function(data){
                    var seckill_data   = data.data.seckill;
                    that.reload_time   = data.data.time_interval;
                    that.stock_num     = seckill_data.stock_num;

                    $('.stock_num p').text(that.stock_num+'件');

                    ////无论什么时候,只要库存为0,就提示库存不足且秒杀结束
                    //if(that.stock_num == 0 && seckill_data.lifecycle != 11) {
                    //    //lib.notification.simple("库存不足",'',1000);
                    //    $('.activity-bottom .btn-buy').text('秒杀结束');
                    //    that.at && that.at.stop();
                    //    clearInterval(intervalCode);
                    //    $('.timer-box .label').text('已结束');
                    //    if ($('.btn-buy').hasClass('active')) {
                    //        $('.btn-buy').removeClass('active');
                    //    }
                    //    return;
                    //}

                    //if(that.seckill) {
                    //    that.seckill = false;
                    //    if(seckill_data.lifecycle == 2 && that.lifecycle == 1) {
                    //        $('.activity-bottom .btn-buy').text('立即秒杀').addClass('active');
                    //        $('.timer-box .label').text('距结束仅剩');
                    //        that.killSeckill = true;
                    //    } else {
                    //        $('.activity-bottom .btn-buy').text('秒杀结束');
                    //        $('.timer-box .label').text('已结束');
                    //        if ($('.btn-buy').hasClass('active')) {
                    //            $('.btn-buy').removeClass('active');
                    //        }
                    //        that.killSeckill = false;
                    //    }
                    //}
                    if(seckill_data.lifecycle != that.lifecycle){

                        //console.log(seckill_data.lifecycle, '进入秒杀', Date.now());

                        that.lifecycle_new = seckill_data.lifecycle;
                        that.system_time_new = data.data.current_time;
                        that.seckillLifecycle(true, that.stock_num);

                        // 重置，正常轮询
                        refreshInterval = null;
                    }
                    // todo 应该没有必要
                    //else{
                    //    that.at && that.at.stop();
                    //    clearInterval(intervalCode);
                    //    if(that.killSeckill || that.middleSeckill) {
                    //        that.activityTimer(that.end_time - data.data.current_time);
                    //    }
                    //}
                    var timeout = refreshInterval || that.reload_time;
                    if(timeout){
                        clearTimeout(that.load_timer);
                        that.load_timer = setTimeout(function(){
                            //refreshInterval && console.log('快速同步服务端状态', Date.now());
                            that.refreshSeckill(refreshInterval);
                        }, timeout);
                    }
                },
                error: function(){

                },
                complete: function(){
                    that.isAjaxGroupRefresh = false;
                }
            });
        },

        // 秒杀
        seckillApply: function(){
            var that = this;
            if(that.isAjaxSeckill){return;}
            that.isAjaxSeckill = true;
            lib.api.post({
                needLogin:true,
                api:'seckill/apply',
                data:{
                    "sku_uid": that.sku_uid,
                    "seckill_uid": that.secKillUid
                },
                //mock:{
                //    path:'./data/seckill.json'
                //},
                success: function(data){
                    if(data.code == 10000){
                        that.goToConfirmOrder();
                    }
                },
                error: function(data){
                    // lib.notification.simple(data.msg, 1000);
                    that.seckillLifecycle();
                },
                complete: function(){
                    that.isAjaxSeckill = false;
                }
            });
        }
    };

    // run
    $(function () {
        main.init();
    })
})(Zepto, window.Global || (window.Global = {}));
/**
 *  透传
 */
;(function ($, mod) {

    mod.deliver = {
        init: function () {
            var httpUrl = new lib.httpurl(location.href);
            this.hostName = httpUrl.origin;
            this.params = httpUrl.params;
            this.code = this.params['_code_'] || '';

            if (!this.code) {
                return;
            }

            this.addEvent();
        },

        addEvent: function () {
            var that = this;
            $('body').on('click', 'a', function (e) {
                var $self = $(this);
                var href = $self[0].href;
                var url = '';

                if (href) {
                    var lowerHref = href.toLowerCase();
                    if (lowerHref.indexOf('javascript') == -1 && lowerHref.indexOf('tel:') == -1) {
                        url = href;
                    }
                }

                if (url) {
                    e.preventDefault();
                    that.deliverUrl(url);
                }
            })
        },

        deliverUrl: function (url) {
            if (!url) return;

            if (url.indexOf('http://') == -1) {
                url = [location.protocol, '//', location.host, location.pathname.replace(/(.*)\/([^\/]*)/, '$1/'), url].join('');
            }

            // todo 先写死 _code_
            if (this.code) {
                var httpurl = new lib.httpurl(url);
                httpurl.params['_code_']= this.code;

                location.href = httpurl.toString();
            } else {
                location.href = url;
            }
        }
    };

    // run
    $(function () {
        mod.deliver.init();
    });

})(Zepto,  window['mod'] || (window['mod'] = {}))