/**
 * Created by qianqian on 15/5/8.
 * 公共处理
 */

//价格
var HDL = (function () {
    var main = {

        init: function(){
            return this;
        },

        // 验证是否是跨境版本的
        checkHigoMark: function (cb) {
            var bizInfo = lib.storage.get('biz_info') || {};
            if (typeof bizInfo.higo_mark != 'undefined') {
                cb && cb(lib.storage.get('biz_info'));
                return;
            }
            var that = this;
            if(this.mallAjax) {return;}
            this.mallAjax = true;
            lib.api.get({
                api: 'auth/session_token/get',
                data: {},
                success: function(data) {
                    var biz_info = data.data.biz_info;
                    lib.storage.set('biz_info', biz_info);

                    cb && cb(biz_info);
                },
                error: function() {
                    cb && cb.call();
                },
                complete: function() {
                    that.mallAjax = false;
                }
            });
        },

        //小数位为0直接显示整数，有一位显示一位，有多位显示两位
        price: function(data){
            if(data){
                var yuan = Number(data/100);
                var fixed0 = yuan.toFixed(0);
                var fixed1 = yuan.toFixed(1);
                var fixed2 = yuan.toFixed(2);

                if(Number(fixed0)==Number(fixed1) && Number(fixed1)==Number(fixed2)){
                    return fixed0;
                }else if(Number(fixed0)!=Number(fixed1) && Number(fixed1)==Number(fixed2)){
                    return fixed1;
                }else{
                    return fixed2;
                }
            }else{
                return 0;
            }
        },

        //保留两位小数
        pricetwo: function(data){
            return Number(data/100).toFixed(2);
        },

        // 时间比较
        /**
         *  type  0：YYYY-MM-DD格式  1：YYYY-MM-DD hh:mm:ss格式
         *  a     选择的时间
         *  b     当前时间
         *  msg   不合法时间的提示信息
         */
        timeCompare: function(a, b, type, msg) {
            var arr = a.split("-");
            var starttime = new Date(arr[0], arr[1], arr[2]);
            var starttimes = starttime.getTime();

            var arrs = b.split("-");
            var lktime = new Date(arrs[0], arrs[1], arrs[2]);
            var lktimes = lktime.getTime();

            if (starttimes < lktimes) {
                lib.notification.simple(msg,1000);
                return false;
            }
            return true;
        },

        deleteArrayItem: function(arr, value){
            for (var i = 0; i < arr.length; i++) {
                var index = -1;
                if (arr[i] == value) index = i;
                if(index>-1){
                    arr.splice(index, 1);
                }
                return arr;
            }
        },

        isEmptyObject: function (obj){
            for(var n in obj){return false}
            return true;
        },

        deleteRepeatFormArr: function(arr){
            var res = [];
            var json = {};
            for(var i = 0; i < arr.length; i++){
                if(!json[arr[i]]){
                    res.push(arr[i]);
                    json[arr[i]] = 1;
                }
            }
            return res;
        }
    };

    return main.init();
})();